/*
 * 
 * ----------------------------------------------------------------------------
 * This file is part of JSBML. Please visit <http://sbml.org/Software/JSBML>
 * for the latest version of JSBML and more information about SBML.
 *
 * Copyright (C) 2009-2016 jointly by the following organizations:
 * 1. The University of Tuebingen, Germany
 * 2. EMBL European Bioinformatics Institute (EBML-EBI), Hinxton, UK
 * 3. The California Institute of Technology, Pasadena, CA, USA
 * 4. The University of California, San Diego, La Jolla, CA, USA
 * 5. The Babraham Institute, Cambridge, UK
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation. A copy of the license agreement is provided
 * in the file named "LICENSE.txt" included with this software distribution
 * and also available online as <http://sbml.org/Software/JSBML/License>.
 * ----------------------------------------------------------------------------
 */

/**
 * Provides classes for the <a
 * href="http://sbml.org/Community/Wiki/SBML_Level_3_Proposals/Flux_Constraints">
 * Flux Balance Constraints</a> package (FBC).
 * <p>
 * The current JSBML implementation of this package follow the FBC <a href=
 * "http://identifiers.org/combine.specifications/sbml.level-3.version-1.fbc.version-1.release-1"
 * >version 1 release 1</a> specifications.
 * 
 * <p><img alt="JSBML" height="54" src="http://sbml.org/images/7/79/xJsbml-logo-54px.png.pagespeed.ic.am7oEUtfpP.png">
 *
 * @author Nicolas Rodriguez
 * @since 1.0
 */
package org.sbml.jsbml.ext.fbc;
